#ifndef ALBUMITEM_H
#define ALBUMITEM_H

#include "qlistview.h"
#include "hackedurloperator.h"
#include "downloadgenerator.h"
#include "trackitem.h"

class AlbumItem : public QObject, public QListViewItem, public DownloadGenerator
{
Q_OBJECT

public:
  AlbumItem(QListViewItem *parent, QString artist, QString album, QString url);
  virtual void setOpen(bool o);
  virtual void initDownloads(SearchView *fromhere);

private slots:
  void slotTransferDone(QString *data);

private:
  bool hasdata;
  bool findingdata;
  bool downloadatdone;
  SearchView *signalemitter;
  HackedUrlOperator getter;
  QPtrList<TrackItem> tracks;
  QString artist;
  QString album;
};
  
#endif // ALBUMITEM_H
