#include "qptrlist.h"
#include "qlistview.h"

#include "artistitem.h"

ArtistItem::ArtistItem(QListView *parent, QString artist)
  : QListViewItem(parent, artist), namehits(1) 
{
  names.insert(artist,1);
}

void ArtistItem::addChild(QString artist, AlbumItem *item)
{
  albums.append(item);
  if (!names.contains(artist)) names.insert(artist,1);
  else names.insert(artist,names[artist]+1);
  if (names[artist] > namehits) {
    setText(0, artist);
    namehits = names[artist];
  }
}

void ArtistItem::initDownloads(SearchView *fromhere)
{
  QPtrListIterator<AlbumItem> it(albums);
  for (;it.current(); ++it) {
    it.current()->initDownloads(fromhere);
  }
}

