#include <iostream>

#include "qstring.h"
#include "qregexp.h"

#include "config.h"
#include "transfer.h"
#include "transferagent.h"
#include "transfergenerator.h"
#include "hubstatusview.h"
#include "dcbackend.h"
#include "downloadview.h"
#include "controller.h"
#include "id3interface.h"

DcBackend *backend;

bool controllerAcceptAudioTransfer(QString file, QString artist, QString album, QString title,
				   int trackno, int length)
{
#warning Check file for correct length / id3 tag?

  if (global_config->setid3)
    Id3Interface::writeId3(file, artist, album, title, trackno);

  static_cast<void>(length); /* Warning eater */

  artist.replace(QRegExp("/")," ");
  album.replace(QRegExp("/")," ");
  title.replace(QRegExp("/")," ");
  QString tracknostr;
  tracknostr.setNum(trackno);
  if (trackno < 10) tracknostr = "0"+tracknostr;

  QString path = global_config->fileformat;

  path.replace(QRegExp("%a"),artist);
  path.replace(QRegExp("%l"),album);
  path.replace(QRegExp("%t"),title);
  path.replace(QRegExp("%n"),tracknostr);
  path = global_config->downloaddir + "/" + path;

  const char *cpath = path.latin1();
  char *tstr  = new char[strlen(cpath)+1];
  for (int i=0; i < path.contains('/'); i++) {
    /* Get the string up to (and including) the n:th /
       using some good old C string coding */
    int count = i;
    int pos;
    for (pos=0; count >= 0; pos++) {
      tstr[pos] = cpath[pos];
      if (tstr[pos] == '/') count--;
    }
    tstr[pos] = 0;
    system((QString("mkdir \"")+tstr+"\" 2>/dev/null").latin1());
  }
  delete [] tstr;
    
  system((QString("mv \"")+file+"\" \""+path+"\"").latin1());
  std::cout << "File downloaded to " << path << std::endl;
  return true;
}

bool controllerCreateAudioTransfer(QString artist, QString album, QString title,
				   int trackno, int length)
{
  backend->generateAudioTransfer(artist, album, title, trackno, length);
  saveTransfer(AudioTransfer(artist, album, title, trackno, length));
  return true;
}

void controllerEndAudioTransfer(QString artist, QString album, QString title,
				int trackno, int length)
{
  removeTransfer(AudioTransfer(artist, album, title, trackno, length));
}

void controllerSetup(TransferAgent *view, HubStatusView *hview)
{
  backend = new DcBackend(view, hview);
  QValueList<AudioTransfer> transfers = retrieveTransfers();
  QValueList<AudioTransfer>::iterator it;
  for (it = transfers.begin(); it != transfers.end(); ++it) {
    backend->generateAudioTransfer((*it).artist, (*it).album, (*it).title,
				   (*it).trackno, (*it).length);
  }
}

void controllerShutdown()
{
  QValueList<int> hubs = listHubs();
  QValueList<int>::iterator it;
  for (it = hubs.begin(); it != hubs.end(); ++it) {
    if (backend) backend->killHub(*it);
  }
}

DcBackend *controllerBackend()
{
  return backend;
}
