#ifndef PAINTLISTVIEWITEM_HPP
#define PAINTLISTVIEWITEM_HPP

#include <map>
#include <qlistview.h>

#include "paintwidget.h"


class PaintListViewItem : public QListViewItem
{
public:
    PaintListViewItem(QListView *parent) 
        : QListViewItem(parent) {}
    PaintListViewItem(QListViewItem *parent) 
        : QListViewItem(parent) {}
    PaintListViewItem(QListView *parent, QListViewItem *after) 
        : QListViewItem(parent, after)  {}
    PaintListViewItem(QListViewItem * parent, QListViewItem *after) 
        : QListViewItem(parent, after){}

    virtual ~PaintListViewItem();

    void addPaintWidget(int column, PaintWidget *w);
    
    void paintCell(QPainter *p, const QColorGroup &cg, 
                   int column, int width, int align);
    
    int width(const QFontMetrics &fm, const QListView *lv, 
              int column) const;

    void paintFocus(QPainter *p, const QColorGroup &cg, 
                    const QRect &r);

    void setText(int column, const QString &text);

    QString text(int column) const;
    
private:    
    std::map<int, PaintWidget*> widgets;
};

#endif
