#ifndef PAINTPROGRESS_H
#define PAINTPROGRESS_H

#include <qstring.h>

#include "paintwidget.h"

class QListViewItem;

class PaintProgress : public PaintWidget
{
public:
    PaintProgress(QListViewItem *parent, int max) 
        : parent(parent), text_(""), max(max), 
          prog(0), prog2(0), w(10) {}

    void setText(const QString &text);
    QString text();

    void setProgress(int progress);
    void setProgress2(int progress);
    void increment();
    
    virtual void paint(QPainter *p, const QColorGroup &cg, 
                       int height, int width, int align);

    virtual int width(const QFontMetrics &fm) const;
    
private:
    QListViewItem *parent;
    QString text_;
    int max;
    int prog;
    int prog2;
    int w;
};

#endif // PAINTPROGRESS_H

