#ifndef SEARCHVIEW_H
#define SEARCHVIEW_H

#include "qhbox.h"
#include "qvbox.h"
#include "qpopupmenu.h"

#include "searchresults.h"
#include "searchwhatbox.h"
#include "searchgenrebox.h"
#include "searchbox.h"
#include "rootgetter.h"

class SearchView : public QVBox
{
Q_OBJECT

public:
  SearchView(QWidget *parent = 0);
  virtual void show();
private slots:
  void startSearch();
  void doPopupMenu(QListViewItem *item, const QPoint &pos, int col);
private:
  SearchResults *results;
  QHBox *optionsbox;
  SearchWhatBox *searchwhat;
  SearchGenreBox *searchgenre;
  SearchBox *searchbox;
  QPopupMenu *menu;
  RootGetter *rootgetter;
};

#endif // SEARCHVIEW_H
