#include "qregexp.h"
#include "qlistview.h"
#include "trackitem.h"

#include "controller.h"

TrackItem::TrackItem(QListViewItem *parent, int track, QString artist, 
		     QString album, QString title, QString length) 
  : QListViewItem(parent, QString().setNum(track)+". "+title, length),
    track(track), artist(artist), album(album), 
    title(title), length(parseLength(length))
{}


int TrackItem::compare(QListViewItem *i, int col, bool ascending) const
{
  if (col != 0) return QListViewItem::compare(i, col, ascending);
  if (((TrackItem*)i)->track == track) return 0;
  if (((TrackItem*)i)->track >  track) return -1;
  return 1;
}

void TrackItem::initDownloads(SearchView *fromhere)
{
  static_cast<void>(fromhere); /* Warning eater */
  controllerCreateAudioTransfer(artist, album, title, track, length);
}

long TrackItem::parseLength(QString length)
{
  QRegExp lengthex("(\\d*):(\\d*)");
  lengthex.search(length);
  return lengthex.cap(1).toLong() * 60 + lengthex.cap(2).toLong();
}
