#ifndef TRACKITEM_H
#define TRACKITEM_H

#include "qlistview.h"
#include "downloadgenerator.h"
#include "searchview.h"

class TrackItem : public QListViewItem, public DownloadGenerator
{
public:
  TrackItem(QListViewItem *parent, int track, QString artist, 
	    QString album, QString track, QString length);
  virtual int compare(QListViewItem *i, int col, bool ascending) const;
  virtual void initDownloads(SearchView *fromhere);
private:
  static long parseLength(QString length);
  int track;
  QString artist;
  QString album;
  QString title;
  long length;
};

#endif // TRACKITEM_H
