#include "transfer.h"
#include "transferagent.h"

Transfer::Transfer(TransferAgent *agent, QString id) : 
  agent(agent) 
{ if (agent) agent->transferCreated(this, id); }

Transfer::~Transfer() 
{ if (agent) agent->transferRemoved(); }

/* Functions that are mapped to TransferAgent */
TransferAgent *Transfer::transferChildCreated()
{ return agent?agent->transferChildCreated():false; }

void Transfer::transferStatusChanged(QString status, long pos, long size,
				    long speed, long eta,
				    double progress, double target)
{ if (agent) agent->transferStatusChanged(status, pos, size, speed, eta, progress, target); }

void Transfer::transferCompleted()
{ if (agent) agent->transferCompleted(); }

void Transfer::transferRemoved()
{ if (agent) agent->transferRemoved(); }

