#ifndef TRANSFERAGENT_H
#define TRANSFERAGENT_H

#include "qstring.h"

class Transfer;
class TransferAgent
{
public:
  TransferAgent() : transfer(0) {}
  virtual void transferCreated(Transfer *transfer, QString id)
  { this->transfer = transfer; static_cast<void>(id); /* Kill warning */ } 
  virtual void transferStatusChanged(QString status = 0, long pos = -1, long size = -1,
				     long speed = -1, long eta = -1,
				     double progress = -1, double target = -1) 
  {
    /* Shut the warnings up, this is just a dummy implementation */
    static_cast<void>(status);
    static_cast<void>(pos);
    static_cast<void>(size);
    static_cast<void>(speed);
    static_cast<void>(eta);
    static_cast<void>(progress);
    static_cast<void>(target);
  }
  virtual void transferCompleted() {}
  virtual void transferRemoved() { transfer = 0; }
  virtual TransferAgent *transferChildCreated() { return 0; }

protected:
  /* Functions that are mapped to Transfer */
  bool createTransfer(TransferAgent *agent, QString id);
  bool startTransfer();
  bool stopTransfer();
  bool resetTransfer();
  bool abortTransfer();
  bool modifyTransfer(QString & newkey);

  bool allowesCreateTransfer();
  bool allowesStartTransfer();
  bool allowesStopTransfer();
  bool allowesResetTransfer();
  bool allowesAbortTransfer();
  bool allowesModifyTransfer();

private:
  Transfer *transfer;
};

#endif // TRANSFERAGENT_H
